/*---------------------------
Vvoj okennho systmu ve WinAPI
Bakalsk prce 2006, 
autor: Dolej Petr
login: xdolej06
Fakulta Informanch Technologi v Brn
---------------------------*/
/*
soubor ivview_functions.cpp obsahuje samotn jdro IVView
soubor ivview_user_functions.cpp obsahuje uivatelskou interakci na vznikl podnty
(vbr poloky menu,procedura okna apod.)
*/

/*------------------------------------------------------------------------------------
Tento soubor obsahuje prezentaci monho pouit navrenho okennho rozhran ve WinAPI
--------------------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>



// Global variables

# include "IVView/ivview_functions.h"
# include "IVView/ivview_user_functions.h"
# include "prezentace.h"

# include "Okenni rozhrani/SoWindow.h"
# include "Okenni rozhrani/SoWinMenu.h"
# include "Library/Common.h"

 SoOrthographicCamera *overlayCamera;  
 SbBool useWalkViewer = FALSE;
 SbBool showPerfMeter = FALSE;
 int numTris = 0;
 int numFramesRendered = 0;
 SbBool ivfix = FALSE;
 SbBool shapeHintBackface = FALSE;
 

 SoWindow Uvodni_Okno;

 SoWinViewer *viewer = NULL;
 SoWinViewer *viewer1 = NULL;
 SoWinViewer *viewer2 = NULL;
 SoWinViewer *viewer3 = NULL;
 SoWinViewer *viewer4 = NULL;

 FileInfo files = { 0, NULL, NULL, NULL, NULL, NULL };
 FileInfo files1 = { 0, NULL, NULL, NULL, NULL, NULL };
 FileInfo files2 = { 0, NULL, NULL, NULL, NULL, NULL };
 FileInfo files3 = { 0, NULL, NULL, NULL, NULL, NULL };
 FileInfo files4 = { 0, NULL, NULL, NULL, NULL, NULL };

 SoWinMENU Uvodni_Menu;
 SoWindow Okno1;
 SoWindow Okno2;
 SoWindow Okno3;

 SoWinMENU Menu;
 SoWinMENU Menu2;
 SoWinMENU Menu3;
 SoWinMENU Menu4;
 SoWinMENU Menu5;
 SoWinMENU Menu6;

/*ukzka pouit MDI oken*/
 void Prezentace_MDI(){

	/*nastaven parametr tdy a vlastnost vytvenho okna*/
	SoWindow_Class WinClass;
	SoWindow_Parameters WinParam;

	WinClass.lpszClassName="Prezentace 2";
	WinClass.mask=WC_LPSZCLASSNAME;
	
	WinParam.lpClassName="Prezentace 2";
	WinParam.mask=WP_LPCLASSNAME;
	
	/*inicializace a vytvoen okna*/
 	HWND window = Okno1.Init(WinClass,WinParam);

	/*vytvoen MDI oken*/
	HWND MDIOkno_1=Okno1.CreateNewMDIChild("1");
	HWND MDIOkno_2=Okno1.CreateNewMDIChild("2");
	HWND MDIOkno_3=Okno1.CreateNewMDIChild("3");
	HWND MDIOkno_4=Okno1.CreateNewMDIChild("4",true,NULL,MyChildProces);
    
	
	/*nastaven titulku oken*/
	Okno1.SetMDIWindowTitle(MDIOkno_1,"Okno 1");
	Okno1.SetMDIWindowTitle(MDIOkno_2,"Okno 2");
	Okno1.SetWindowTitle("MDI (Multiple Document Interface)");

	/*inicializace a vytvoen menu*/
	Menu.Init(MDIOkno_1);
	/*naten menu ze souboru a piazen procedury menu*/
	HMENU hMenumain = Menu.CreateMDIMenufromFile("Menu/menu1.txt",processTopbarEvent1);

	Menu2.Init(MDIOkno_2);
	Menu2.CreateMDIMenufromFile("Menu/menu2.txt",processTopbarEvent2);

	Menu3.Init(MDIOkno_3);
	Menu3.CreateMDIMenufromFile("Menu/menu3.txt",processTopbarEvent3);
	
	Menu4.Init(MDIOkno_4);
	Menu4.CreateMDIMenufromFile("Menu/menu4.txt",processTopbarEvent4);
	
	/*Inicializace jednolivch IVViewr*/
	viewer1 = new SoWinExaminerViewer(MDIOkno_1);
	viewer2 = new SoWinExaminerViewer(MDIOkno_2);
	viewer3 = new SoWinExaminerViewer(MDIOkno_3);
	viewer4 = new SoWinExaminerViewer(MDIOkno_4);
	

	files1.count = 1;
    files1.names = (char **) malloc (files1.count * sizeof(char *));
	files1.super = new SoGroup;
    files1.super->ref();
    files1.super->addChild(new SoSeparator);
    files1.super->addChild(new SoSeparator);
	viewer1->setSceneGraph(files1.super);

	files2.count = 1;
    files2.names = (char **) malloc (files2.count * sizeof(char *));
	files2.super = new SoGroup;
    files2.super->ref();
    files2.super->addChild(new SoSeparator);
    files2.super->addChild(new SoSeparator);
	viewer2->setSceneGraph(files2.super);

	files3.count = 1;
    files3.names = (char **) malloc (files3.count * sizeof(char *));
	files3.super = new SoGroup;
    files3.super->ref();
    files3.super->addChild(new SoSeparator);
    files3.super->addChild(new SoSeparator);
	viewer3->setSceneGraph(files3.super);
	
	files4.count = 1;
    files4.names = (char **) malloc (files4.count * sizeof(char *));
	files4.super = new SoGroup;
    files4.super->ref();
    files4.super->addChild(new SoSeparator);
    files4.super->addChild(new SoSeparator);
	viewer4->setSceneGraph(files4.super);
	
	viewer1->show();
	viewer2->show();
	viewer3->show();
	viewer4->show();
	
	SoWinViewer *Viewer_pom = viewer;
	FileInfo Files_pom = files;
	
	files=files1;	/*naten model pi inicializaci*/
	viewer=viewer1;
	newSceneCB("Models/honda.wrl");
	
	files=files2;
	viewer=viewer2;
	newSceneCB("Models/dolphins.wrl");
	
	files=files3;
	viewer=viewer3;
	newSceneCB("Models/kerolamp.wrl");
	
	files=files4;
	viewer=viewer4;
	newSceneCB("Models/woodman.wrl");
	
	viewer=Viewer_pom;
	files=Files_pom;

	/*zobrazen okna (maximalizovan)*/
	Okno1.Show(SW_MAXIMIZE);
	/*smyka zprv*/
	Okno1.mainLoop();
	::SendMessage(GetParent(Okno1.GetMDIActiveHWND()), WM_MDITILE, 0, 0);
	::MessageBox(
			 NULL,
			"Ukzka vyuit MDI rozhran pro Ivview, \n \
co umouje vyuit pln funkn Ivview se vemi \n \
monostmi ve vce instancch. Tato jednotliv okna jsou \n \
na sob vzjemn nezvisl a tm umouj jejich pouit \n \
odlinm zpsobem. Jejich pohyb je omezen v rmci jejich \n \
nadazenho hlavnho okna. Pro jednodu prci s nimi, \n \
je zde pidna (voliteln monost pi vytven okna) poloka v menu \n \
[Windows], kter usnaduje uspodvn oken.\n \
Kad okno m svoje vlastn menu,\n \
naten z textovho souboru. \n \
Okna mohou mt vlastn obsluhu zprv (pklad okna 4 pi jeho uzaven).\n \
Samozejm nechyb jako v pedchoz ukzce monost omezen pohybu okna.\n \
Pro zbnou prezentaci dalch monost slou poloka menu: \n \
[Prezentace rozhran]->[Dal]",
"Prezentace vybranch st okennho rozhran ve WinAPI",
		    MB_OK);

}

/*Prezentace nastaven vlastn procedury okna a tm vlastnho zpracovn zprv okna*/
void Vlastni_WndProc(){

	/*nastaven parametr tdy a vlastnost vytvenho okna*/
	SoWindow_Class WinClass;
	SoWindow_Parameters WinParam;

	WinClass.lpszClassName="Prezentace 3";
	WinClass.mask=WC_LPSZCLASSNAME;
	WinParam.lpClassName="Prezentace 3";
	
	WinParam.dwStyle=WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX;
	WinParam.mask=WP_LPCLASSNAME|WP_DWSTYLE;
	
	/*nastaven procedury okna*/
	Okno2.UserWndProc=MyWndProc_Okno2;
	
	/*vytvoen okna*/
 	HWND window = Okno2.Init(WinClass,WinParam);    
	
	/*nastaven titulku okna*/
	Okno2.SetWindowTitle("Ukzka vestrannho vyuit okna");

	/*nastaven menu*/
	Menu5.Init(window);
	Menu5.CreateMenufromFile("Menu/Menu_WndProc_Okno2.txt",Prezentace_3_okno1);
	
	/*nastaven parametr tdy a vlastnost dalho vytvenho okna*/
	WinClass.lpszClassName="Prezentace 4";
	WinClass.mask=WC_LPSZCLASSNAME;
	WinParam.lpClassName="Prezentace 4";
	/*nastaven jinho stylu okna ne standadnho*/
	WinParam.dwStyle=WS_OVERLAPPEDWINDOW|WS_MINIMIZEBOX|WS_MAXIMIZEBOX;
	//	WS_THICKFRAME	lze menit velikost
	//  WS_MINIMIZEBOX  moznost minimalizovat
	//  WS_MAXIMIZE 
	WinParam.dwExStyle=WS_EX_TOPMOST;
	WinParam.nHeight=250;
	WinParam.nWidth=600;
	WinParam.mask=WP_LPCLASSNAME|WP_DWSTYLE|WP_DWEXSTYLE|WP_NHEIGHT|WP_NWIDTH;
	
	/*Vytvoen samotnho okna*/
 	window = Okno3.Init(WinClass,WinParam);    
	
	Okno3.SetWindowTitle("Okno 2 s vlastn obsluhou smyky zprv a uitm stylem WS_EX_TOPMOST");
	/*nastaven procedury okna*/
	Okno3.UserWndProc=MyWndProc_Okno3;

	/*nastaven menu*/
	Menu6.Init(window);
	Menu6.CreateMenufromFile("Menu/Menu_WndProc.txt",Prezentace_3_okno2);
	
	/*zobrazen oken a pepnut do smyky zprv*/
	Okno3.Show(-1);
	Okno2.Show(-1);
	Okno2.mainLoop();
	
	::MessageBox(
			 NULL,
			"Toto je ukzka dvou na \n \
sob naprosto nezvislch oken, se zpracovnm \n \
jejich smyky zprv a monost vyuit rznch styl oken.\n \
(vech definovanch v MSDN).\n \
Jedno okno reaguje na stisk levho tlatka myi, \n \
v druhm je naznaeno, e nen problm okno vyut k \n \
naprosto libovolnmu pouit. \n \
(protoe uivatel m k dispozici monost vlastn obsluhy smyky zprv).",
"Prezentace vybranch st okennho rozhran ve WinAPI",
		    MB_OK);

	Okno3.mainLoop();

}
int
main(int argc, char **argv)
{  	 
#ifdef _WIN32
	// Parse command line arguments
	parse_args(argc, argv);

	// This precomputes correct program name from argv[0],
    // because using argv[0] for program name is not a good solution on Windows.
    updateProgName(argv[0]);


	/*ponechn standatrdnch nastaven pro tdu a vlastnosti okna*/
	SoWindow_Class WinClass;
	SoWindow_Parameters WinParam;
	WinClass.mask=0;
	WinParam.mask=0;
	
	//inicializace Uvodniho okna 
	HWND uvodni = Uvodni_Okno.Init(WinClass,WinParam);
	//inicializace Inventoru
	SoWin::init(uvodni);
	//nastaven titulku
	Uvodni_Okno.SetWindowTitle("vodn samostatn okno pro Ivview");
	
	/*inicializace menu*/
	Uvodni_Menu.Init(uvodni);
	
	/*naten menu ze souboru a piazen procedury menu*/
	Uvodni_Menu.CreateMenufromFile("Menu/uvodni_menu.txt",Obsluha_Uvodni_Menu);
	
	/*inicializace IVVieweru*/
	viewer = new SoWinExaminerViewer(uvodni);

    // Create super scene
    // Appended by PCJohn because of overlays workaround.
    files.super = new SoGroup;
    files.super->ref();
    files.super->addChild(new SoSeparator);
    files.super->addChild(new SoSeparator);
    viewer->setSceneGraph(files.super);

	viewer->show();
	newSceneCB("Models/woodman.wrl");
	/*zobrazen okna*/
	Uvodni_Okno.Show(-1);

	::MessageBox(
			 NULL,
			"Toto samostatn okno pro Ivview \n \
je pln funkn se vemi monostmi Ivview. \n \
Pro ukzku je doplnno menu o monosti prce \n \
s oknem (omezovn jeho pohybu). Toto menu je \n \
nateno z textovho souboru \"uvodni_menu.txt\",\n \
co umouje nepouvat resource soubory, \n \
kter nemus bt v nkterch pekladach podporovny...\n \
Pro zbnou prezentaci dalch monost slou poloka menu: \n \
[Prezentace rozhran]->[Dal]",
"Prezentace vybranch st okennho rozhran ve WinAPI",
		    MB_OK);

    // Read the input scene from the file(s)
    SbBool readOk = readScene(files);
//    if(!readOk) return false; 
    // The lower left corner of the window is used to draw
    // the tris/second meter (if enabled)
    if (showPerfMeter)
        initPerfMeter(viewer);

    setBusyCursor(FALSE);


	/*smyka zprv okna*/
	Uvodni_Okno.mainLoop();
	Uvodni_Menu.CloseAll();
#endif
	return 0;

}